import org.junit.Rule;
import org.junit.Test;
import java.lang.reflect.Method;
import org.junit.rules.Timeout;

import static org.junit.Assert.assertEquals;

public class Aufgabe5Test {

    @Rule
    public Timeout globalTimeout = new Timeout(100);

    @Test
    public void testInRangeAndOrdered() throws Exception{
        Method method = Aufgabe5.class.getDeclaredMethod("inRangeAndOrdered", int.class, int.class);
        assertEquals(true, method.getReturnType().equals(Boolean.TYPE));
        method.setAccessible(true);
        assertEquals(true, method.invoke(null, 20, 1));
        assertEquals(false, method.invoke(null, 1, 20));
        assertEquals(false, method.invoke(null, 21, 1));
        assertEquals(false, method.invoke(null, 20, 0));
        assertEquals(true, method.invoke(null, 4, 3));
        assertEquals(false, method.invoke(null, 3, 4));
    }

    @Test
    public void testWiredLogic() throws Exception{
        Method method = Aufgabe5.class.getDeclaredMethod("wiredLogic", boolean.class, boolean.class);
        assertEquals(true, method.getReturnType().equals(Integer.TYPE));
        method.setAccessible(true);
        assertEquals(-1, method.invoke(null, false, false));
        assertEquals(0, method.invoke(null, false, true));
        assertEquals(0, method.invoke(null, true, false));
        assertEquals(1, method.invoke(null, true, true));
    }

    @Test
    public void testCombinedLogic() throws Exception{
        Method method = Aufgabe5.class.getDeclaredMethod("combinedLogic", boolean.class, boolean.class);
        assertEquals(true, method.getReturnType().equals(Integer.TYPE));
        method.setAccessible(true);
        assertEquals(0, method.invoke(null, false, false));
        assertEquals(1, method.invoke(null, false, true));
        assertEquals(2, method.invoke(null, true, false));
        assertEquals(3, method.invoke(null, true, true));
    }

    @Test
    public void testUseSwitch() throws Exception{
        Method method = Aufgabe5.class.getDeclaredMethod("useSwitch", int.class);
        assertEquals(true, method.getReturnType().equals(Boolean.TYPE));
        method.setAccessible(true);
        assertEquals(true, method.invoke(null, 1));
        assertEquals(true, method.invoke(null, 2));
        assertEquals(true, method.invoke(null, 3));
        assertEquals(true, method.invoke(null, 4));
        assertEquals(false, method.invoke(null, 5));
    }

    @Test
    public void testSquareNumbers() throws Exception{
        Method method = Aufgabe5.class.getDeclaredMethod("squareNumbers", int.class, int.class);
        assertEquals(true, method.getReturnType().equals(Integer.TYPE));
        method.setAccessible(true);
        assertEquals(3, method.invoke(null, 4, 16));
        assertEquals(808, method.invoke(null, -100, 654321));
        assertEquals(0, method.invoke(null, 45, 4));
        assertEquals(217, method.invoke(null, 10000, 100000));
        assertEquals(1, method.invoke(null, 64, 64));
    }
}